SystemOrganization addCategory: #ConfigurationOfPlatypus!

Object subclass: #ConfigurationOfPlatypus
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPlatypus'!

!ConfigurationOfPlatypus commentStamp: '<historical>' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'MyProject'
                repository: 'http://www.example.com/MyProjectRepository'
                requiredProjects: #('Gofer')
                packages: #('MyProject-Core' 'MyProject-Tests')
                dependencies:
                        {('MyProject-Core' -> #('Gofer')).
                         ('MyProject-Tests' -> #('MyProject-Core'))}
                groups:
                        {('default' -> #('Core')).
                        ('Core' -> #('MyProject-Core')).
                        ('Tests' -> #('MyProject-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'MyProject'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfPlatypus class methodsFor: 'development support' stamp: 'AlainPlantec 12/10/2013 09:50'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPlatypus class methodsFor: 'private' stamp: 'AlainPlantec 12/10/2013 09:50'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #'ConfigurationOf'
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #'ConfigurationOf' ifAbsent: aBlock ].
! !

!ConfigurationOfPlatypus class methodsFor: 'private' stamp: 'AlainPlantec 12/10/2013 09:50'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPlatypus class methodsFor: 'private' stamp: 'AlainPlantec 12/10/2013 09:50'!
ensureMetacelloBaseConfiguration
  Smalltalk
    at: #'ConfigurationOf'
    ifAbsent: [ 
      | repository version |
      repository := MCHttpRepository
        location: 'http://smalltalkhub.com/mc/dkh/metacello/main'
        user: ''
        password: ''.
      repository
        versionReaderForFileNamed: 'Metacello-Base-dkh.107'
        do: [ :reader | 
          version := reader version.
          version load.
          version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPlatypus class methodsFor: 'metacello tool support' stamp: 'AlainPlantec 12/10/2013 09:50'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPlatypus class methodsFor: 'loading' stamp: 'AlainPlantec 12/16/2013 08:58'!
load
	self loadDevelopment! !

!ConfigurationOfPlatypus class methodsFor: 'loading' stamp: 'AlainPlantec 12/16/2013 08:58'!
loadBleedingEdge
	self loadDevelopment! !

!ConfigurationOfPlatypus class methodsFor: 'loading' stamp: 'AlainPlantec 12/10/2013 09:50'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPlatypus class methodsFor: 'accessing' stamp: 'AlainPlantec 12/10/2013 09:50'!
project

	^self new project! !

!ConfigurationOfPlatypus class methodsFor: 'development support' stamp: 'AlainPlantec 12/10/2013 09:50'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPlatypus methodsFor: 'baselines' stamp: 'AlainPlantec 12/16/2013 08:56'!
baseline01: spec
	<version: '0.1-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec
				project: 'SmaCCDev'
				with: [ 
					spec
						className: 'ConfigurationOfSmaCC';
						file: 'ConfigurationOfSmaCC';
						repository: 'http://smalltalkhub.com/mc/PharoExtras/Smacc/main';
						loads: #('Runtime' 'Tools') ].
			
			spec group: #PlatypusPetitParser with: [ 
				spec
				project: 'PetitParser'
				with: [ 
					spec repository: 'http://smalltalkhub.com/mc/Moose/PetitParser'.
					spec
						className: 'ConfigurationOfPetitParser';
						versionString: '1.6';
						loads: #(#Core 'Tests') ].
				spec repository: 'http://smalltalkhub.com/mc/PharoExtras/StepExpress/main'.
				spec package: 'PetitStepExpress' with: [ spec requires: 'PetitParser' ]].
			spec repository: 'http://ss3.gemstone.com/ss/Platypus'.
			spec package: 'Tamaris'.
			spec package: 'Platypus' with: [ spec requires: 'SmaCCDev' ].
			spec
				package: 'SqPlatypus'
				with: [ 
					spec
						requires: 'Platypus';
						requires: 'Tamaris' ].
			spec package: 'xtra-platypus' with: [ spec requires: 'SqPlatypus' ].
			spec
				package: 'PlatypusPostLoad'
				with: [ 
					spec
						requires: 'xtra-platypus';
						requires: 'SqPlatypus' ] ]! !

!ConfigurationOfPlatypus methodsFor: 'accessing' stamp: 'AlainPlantec 12/10/2013 09:50'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfPlatypus methodsFor: 'symbolic versions' stamp: 'AlainPlantec 12/10/2013 17:48'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfPlatypus methodsFor: 'accessing' stamp: 'AlainPlantec 12/10/2013 09:50'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !

!ConfigurationOfPlatypus methodsFor: 'versions' stamp: 'AlainPlantec 12/16/2013 08:56'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #development.
			spec description: 'releasing a version of Platypus 1'.
			spec author: 'AlainPlantec'.
			spec timestamp: '10/12/2013 18:01' ]! !
